/* KPrefsServer */

#import <Cocoa/Cocoa.h>
#import "KColorUtils.h"

#define KKEditPrefs				@"kedit_prefs"

//#define KPreferenceDirectory @"Library/Preferences/KEdit"
#define KPreferenceDirectory @"Library/KEdit"
#define KAddOnsDirectoryName @"add-ons"
#define KSettingsDirectoryName @"settings"
#define KTagFileName @"UserDefinedTags.txt"

//BOOLs
//#define KRNStoreWindowStatus @"storeWindowStatus"
#define KRNAutoIndent @"autoIndent"
#define KRNWordWrap @"wordWrap"
#define KRNDetectTextType @"detectTextType"
#define KRNDetectCodeType @"detectCodeType"
#define KRNStoreTextType @"storeTextType"
#define KRNAssignOnlyMultiStroke @"assignOnlyMultiStroke"
#define KRNUseXHTMLSyntax @"useXHTMLSyntax"
#define KRNAlwaysMakesANewWindow @"alwaysMakesANewWindow"

//INTs
#define KRNKeybindType @"keybindType"
#define KRNPrefferedBrowserType @"preferredBrowserType"
#define KRNDocumentReturnCodeType @"returnCodeType"
#define KRNDocumentCharacterCodeType @"characterCodeType"
#define KRNDocumentTextFileFormatType @"textFileFormatType"

#define KRNWrapLineWithReturnCodeWidth @"wrapLineWithReturnCodeWidth"

//STRINGs
#define KRNDocumentFontName  @"documentFontName"

//FLOATs
#define KRNDocumentFontSize @"documentFontSize"

//COLORs
#define KBackgroundColor		@"background_color"
#define KBaseStringColor		@"base_string_color"
#define KTagStringColor			@"tab_string_color"
#define KCommentStringColor		@"comment_string_color"

typedef enum {
  KKeybind_KEditOriginal = 1,
	KKeybind_EmacsLike = 2,
	KKeybind_ViLike = 3,
	KKeybind_SystemDefault = 4
} KKeybindType;

/*
typedef enum {
  KPreferredBrowser_Safari = 1,
	KPreferredBrowser_Camino = 2,
	KPreferredBrowser_IE = 3
} KPreferredBrowserType;
*/

typedef enum {
  KDocumentReturnCode_LF = 1,
	KDocumentReturnCode_CR = 2,
	KDocumentReturnCode_CRLF = 3
} KDocumentReturnCodeType;

typedef enum {
  KDocumentCharacterCode_SJIS = NSShiftJISStringEncoding /* 8 */,
	KDocumentCharacterCode_JIS = NSISO2022JPStringEncoding /* 21 */,
	KDocumentCharacterCode_EUC = NSJapaneseEUCStringEncoding /* 3 */,
	KDocumentCharacterCode_UTF8 = NSUTF8StringEncoding /* 4 */,
	KDocumentCharacterCode_UTF16 = NSUnicodeStringEncoding /* 10 */
} KDocumentCharacterCodeType;

typedef enum {
  KDocumentTextFileFormat_Plain = 1,
  KDocumentTextFileFormat_HTML,
  KDocumentTextFileFormat_CSS,
  KDocumentTextFileFormat_PHP,
  KDocumentTextFileFormat_Ruby,
  KDocumentTextFileFormat_Perl,
  
  KDocumentTextFileFormat_SH,
  
  KDocumentTextFileFormat_Indexed = 50,
  KDocumentTextFileFormat_KIndex
} KDocumentTextFileFormatType;


////////
// KPrefsServer class
////////
@interface KPrefsServer : NSObject
{
	IBOutlet id myWindow;
	IBOutlet id myTabView;
}

- (void)showPreferenceWindow;

//actions.
- (IBAction)okButtonPressed:(id)sender;
- (IBAction)cancelButtonPressed:(id)sender;
- (IBAction)fontSetButtonPressed:(id)sender;

- (IBAction)changeFont:(id)sender;


//for internal use only.
- (void)loadPreferenceWindow;
- (BOOL)windowShouldClose:(id)sender;

//- (void)resetUI;
- (void)dealloc;

@end


@interface NSMutableDictionary (Preferences)

- (BOOL)boolForKey:(id)key;
- (void)setBool:(BOOL)flag forKey:(id)key;
- (float)floatForKey:(id)key;
- (void)setFloat:(float)number forKey:(id)key;
- (int)intForKey:(id)key;
- (void)setInt:(int)number forKey:(id)key;
- (rgb_color)colorForKey:(id)key;
- (void)setColor:(rgb_color)color forKey:(id)key;

@end


@interface NSUserDefaults (Preferences)

- (void)setBoolIfNeeded:(BOOL)value forKey:(NSString*)key;
- (void)setFloatIfNeeded:(float)value forKey:(NSString*)key;
- (void)setIntegerIfNeeded:(int)value forKey:(NSString*)key;
- (void)setObjectIfNeeded:(id)value forKey:(NSString*)key;

@end












