//
//  KRangeObj.h
//  KEdit
//
//  Created by Karino, Masatsugu on Tue May 06 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface KRangeObj : NSObject <NSCoding>{
	unsigned mLocation;
    unsigned mLength;
}

+ (id)rangeObj; //return {0,0} range.
+ (id)rangeObjWithRange:(NSRange)range;
+ (id)rangeObjWithLocation:(unsigned)location andLength:(unsigned)length;
+ (id)rangeObjWithRangeObj:(KRangeObj*)range;
+ (id)rangeObjWithString:(NSString*)string;

- (id)init; //return {0,0} range;
- (id)initWithRange:(NSRange)range;
- (id)initWithLocation:(unsigned)location andLength:(unsigned)length;
- (id)initWithRangeObj:(KRangeObj*)range;
- (id)initWithString:(NSString*)string;

- (BOOL)isEqualToRange:(NSRange)range;
- (BOOL)isEqualTo:(KRangeObj*)range;

- (BOOL)containsLocation:(unsigned)location;
- (BOOL)containsRange:(NSRange)range;
- (BOOL)containsRangeObj:(KRangeObj*)range;
- (BOOL)isContainedWithRangeObjs:(NSArray*)array;

- (void)setLocation:(unsigned)location;
- (void)setLength:(unsigned)length;
- (void)setRange:(NSRange)range;
- (unsigned)location;
- (unsigned)length;
- (NSRange)range;
- (NSString*)string;

- (id)unionRange:(NSRange)range;
- (id)unionRangeObj:(KRangeObj*)range;
- (id)intersectionRange:(NSRange)range;
- (id)intersectionRangeObj:(KRangeObj*)range;
- (unsigned)maxRange;
- (id)shiftRangeObj:(unsigned)shiftLoc;
//- (NSArray*)complementRangeObjs:(NSArray*)rangeArray; // KRangeObj* array.

- (NSComparisonResult)locationCompare:(KRangeObj*)range;

- (id)initWithCoder:(NSCoder*)decoder;
- (void)encodeWithCoder:(NSCoder*)encoder;

@end
