//
//  KWebBrowser.h
//  KEdit
//
//  Created by Karino, Masatsugu on Thu Dec 04 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define KIEBookmarkFileName @"Library/Preferences/Explorer/Favorites.html"
#define KSafariBookmarkFileName @"Library/Safari/Bookmarks.plist"
#define KCaminoBookmarkFileName @"Library/Application Support/Chimera/Profiles/default/rol2jwlu.slt/bookmarks.xml"

typedef enum {
  KWebBrowser_Safari = 1,
	KWebBrowser_Camino = 2,
	KWebBrowser_IE = 3
} KWebBrowserType;


@interface KWebBrowser : NSObject {
  KWebBrowserType mWebBrowserType;
}

- (id)initWithBrowserType:(KWebBrowserType)type;
+ (id)browserWithBrowserType:(KWebBrowserType)type;

- (void)openDocument:(NSDocument*)document requireNewWindow:(BOOL)requireNewWindow;
- (NSMenu*)bookmarksMenuWithSelector:(SEL)selector;

- (KWebBrowserType)webBrowserType;
- (void)setWebBrowserType:(KWebBrowserType)type;


//for internal use.
- (void)constructURLMenuWithIEBookmarks:(NSMenu*)targetMenu selector:(SEL)selector;
- (void)constructURLMenuWithSafariBookmarks:(NSMenu*)targetMenu selector:(SEL)selector;
- (void)constructURLMenuWithSafariBookmarksWithArray:(NSMenu*)targetMenu selector:(SEL)selector array:(NSArray*)array;

@end
